]> git.ipfire.org Git - thirdparty/git.git/blame - git-sh-setup.sh
Add 'git rev-parse --show-toplevel' option.
[thirdparty/git.git] / git-sh-setup.sh
CommitLineData
b33e9666
LT
1#!/bin/sh
2#
ae2b0f15
JH
3# This is included in commands that either have to be run from the toplevel
4# of the repository, or with GIT_DIR environment variable properly.
5# If the GIT_DIR does not look like the right correct git-repository,
6# it dies.
b33e9666 7
365527ad 8# Having this variable in your environment would break scripts because
e598c517 9# you would cause "cd" to be taken to unexpected places. If you
365527ad
JH
10# like CDPATH, define it for your interactive shell sessions without
11# exporting it.
12unset CDPATH
13
61dbb3c4
JH
14git_broken_path_fix () {
15 case ":$PATH:" in
16 *:$1:*) : ok ;;
17 *)
18 PATH=$(
19 SANE_TOOL_PATH="$1"
20 IFS=: path= sep=
21 set x $PATH
22 shift
23 for elem
24 do
25 case "$SANE_TOOL_PATH:$elem" in
26 (?*:/bin | ?*:/usr/bin)
27 path="$path$sep$SANE_TOOL_PATH"
28 sep=:
29 SANE_TOOL_PATH=
30 esac
31 path="$path$sep$elem"
32 sep=:
33 done
34 echo "$path"
35 )
36 ;;
37 esac
38}
39
40# @@BROKEN_PATH_FIX@@
0e0aea5a 41
b33e9666 42die() {
8098a178 43 echo >&2 "$@"
b33e9666
LT
44 exit 1
45}
46
e064c170
SB
47GIT_QUIET=
48
49say () {
50 if test -z "$GIT_QUIET"
51 then
52 printf '%s\n' "$*"
53 fi
54}
55
bac199b7
PH
56if test -n "$OPTIONS_SPEC"; then
57 usage() {
5d292756
JH
58 "$0" -h
59 exit 1
bac199b7
PH
60 }
61
e817e3e8
PH
62 parseopt_extra=
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra="--keep-dashdash"
65
66 eval "$(
cbea86fd 67 echo "$OPTIONS_SPEC" |
e817e3e8
PH
68 git rev-parse --parseopt $parseopt_extra -- "$@" ||
69 echo exit $?
70 )"
bac199b7 71else
1b1dd23f 72 dashless=$(basename "$0" | sed -e 's/-/ /')
bac199b7 73 usage() {
1b1dd23f 74 die "Usage: $dashless $USAGE"
bac199b7
PH
75 }
76
77 if [ -z "$LONG_USAGE" ]
78 then
1b1dd23f 79 LONG_USAGE="Usage: $dashless $USAGE"
bac199b7 80 else
1b1dd23f 81 LONG_USAGE="Usage: $dashless $USAGE
bac199b7
PH
82
83$LONG_USAGE"
84 fi
85
86 case "$1" in
87 -h|--h|--he|--hel|--help)
88 echo "$LONG_USAGE"
89 exit
90 esac
91fi
d025524d 92
f9474132
SP
93set_reflog_action() {
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
95 then
96 GIT_REFLOG_ACTION="$*"
97 export GIT_REFLOG_ACTION
98 fi
99}
100
ef0c2abf 101git_editor() {
b4479f07
JN
102 if test -z "${GIT_EDITOR:+set}"
103 then
104 GIT_EDITOR="$(git var GIT_EDITOR)" || return $?
105 fi
106
107 eval "$GIT_EDITOR" '"$@"'
ef0c2abf
AR
108}
109
e1622bfc
JH
110sane_grep () {
111 GREP_OPTIONS= LC_ALL=C grep "$@"
112}
113
114sane_egrep () {
115 GREP_OPTIONS= LC_ALL=C egrep "$@"
116}
117
4b441f47 118is_bare_repository () {
5be60078 119 git rev-parse --is-bare-repository
4b441f47
JH
120}
121
9fde9401 122cd_to_toplevel () {
5be60078 123 cdup=$(git rev-parse --show-cdup)
9fde9401
JH
124 if test ! -z "$cdup"
125 then
2c3c395e
MC
126 # The "-P" option says to follow "physical" directory
127 # structure instead of following symbolic links. When cdup is
128 # "../", this means following the ".." entry in the current
129 # directory instead textually removing a symlink path element
130 # from the PWD shell variable. The "-P" behavior is more
131 # consistent with the C-style chdir used by most of Git.
132 cd -P "$cdup" || {
133 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
9fde9401
JH
134 exit 1
135 }
136 fi
137}
138
7eff28a9 139require_work_tree () {
e90fdc39 140 test $(git rev-parse --is-inside-work-tree) = true ||
7eff28a9
SP
141 die "fatal: $0 cannot be used without a working tree."
142}
143
0cae2346
JS
144get_author_ident_from_commit () {
145 pick_author_script='
146 /^author /{
147 s/'\''/'\''\\'\'\''/g
148 h
149 s/^author \([^<]*\) <[^>]*> .*$/\1/
150 s/'\''/'\''\'\'\''/g
151 s/.*/GIT_AUTHOR_NAME='\''&'\''/p
152
153 g
154 s/^author [^<]* <\([^>]*\)> .*$/\1/
155 s/'\''/'\''\'\'\''/g
156 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
157
158 g
159 s/^author [^<]* <[^>]*> \(.*\)$/\1/
160 s/'\''/'\''\'\'\''/g
161 s/.*/GIT_AUTHOR_DATE='\''&'\''/p
162
163 q
164 }
165 '
166 encoding=$(git config i18n.commitencoding || echo UTF-8)
077b725f 167 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
0cae2346
JS
168 LANG=C LC_ALL=C sed -ne "$pick_author_script"
169}
170
22c90717
JH
171# Make sure we are in a valid repository of a vintage we understand,
172# if we require to be in a git repository.
70087cdb 173if test -z "$NONGIT_OK"
d025524d 174then
4d6d6d2d 175 GIT_DIR=$(git rev-parse --git-dir) || exit
22c90717
JH
176 if [ -z "$SUBDIRECTORY_OK" ]
177 then
22c90717
JH
178 test -z "$(git rev-parse --show-cdup)" || {
179 exit=$?
180 echo >&2 "You need to run this command from the toplevel of the working tree."
181 exit $exit
182 }
22c90717
JH
183 fi
184 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
185 echo >&2 "Unable to determine absolute path of git directory"
186 exit 1
b2bc9a30 187 }
22c90717 188 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
d025524d 189fi
87bddba9
JS
190
191# Fix some commands on Windows
192case $(uname -s) in
193*MINGW*)
194 # Windows has its own (incompatible) sort and find
195 sort () {
196 /usr/bin/sort "$@"
197 }
198 find () {
199 /usr/bin/find "$@"
200 }
201 ;;
202esac